Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.imageio.plugins.jpeg
Class JPEGHuffmanTable

    java.lang.Object
      |
      +--javax.imageio.plugins.jpeg.JPEGHuffmanTable

public class JPEGHuffmanTable
extends Object

A class encapsulating a single JPEG Huffman table. Fields are provided for the "standard" tables from taken from Annex K of the JPEG specification. These are the tables used as defaults. This class differs from the old unsupported com.sun.image.codec.jpeg.JPEGHuffmanTable in two ways:

1. The lengths arrays for this class do not contain an ignored 0th entry. The lengths array in a JPEG stream does not contain an extra entry, and this class is used to represent the contents of a JPEG stream.
2. The old class incorrectly referred to Huffman "symbols", while expecting an array of values to be encoded. This class has a `getValues` method instead of a `getSymbols` method.

For more information about the operation of the built-in JPEG plug-ins, see the JPEG metadata format specification and usage notes.

Field Summary
`static JPEGHuffmanTable` | `StdACChrominance` The standard AC chrominance Huffman table.
`static JPEGHuffmanTable` | `StdACLuminance` The standard AC luminance Huffman table.
`static JPEGHuffmanTable` | `StdDCChrominance` The standard DC chrominance Huffman table.
`static JPEGHuffmanTable` | `StdDCLuminance` The standard DC luminance Huffman table.

Constructor Summary
`JPEGHuffmanTable(short[] lengths, short[] values)` Creates a Huffman table and initializes it.

Method Summary
`short[]` | `getLengths()` Return an array of `short`s containing the number of values for each length in the Huffman table.
`short[]` | `getValues()` Return an array of `short`s containing the values arranged by increasing length of their corresponding codes.
`String` | `toString()` Returns a string representation of the object.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### StdDCLuminance

    public static final JPEGHuffmanTable StdDCLuminance

  The standard DC luminance Huffman table.

### StdDCChrominance

    public static final JPEGHuffmanTable StdDCChrominance

  The standard DC chrominance Huffman table.

### StdACLuminance

    public static final JPEGHuffmanTable StdACLuminance

  The standard AC luminance Huffman table.

### StdACChrominance

    public static final JPEGHuffmanTable StdACChrominance

  The standard AC chrominance Huffman table.

Constructor Detail

### JPEGHuffmanTable

    public JPEGHuffmanTable(short[] lengths,
                            short[] values)

  Creates a Huffman table and initializes it. The input arrays are copied. The arrays must describe a possible Huffman table. For example, 3 codes cannot be expressed with a single bit.

Parameters:
  `lengths` - an array of `short`s where `lengths[k]` is equal to the number of values with corresponding codes of length `k + 1` bits.
  `values` - an array of `short`s containing the values in order of increasing code length.
Throws:
  `IllegalArgumentException` - if `lengths` or `values` are `null`, the length of `lengths` is greater than 16, the length of `values` is greater than 256, if any value in `lengths` or `values` is less than zero, or if the arrays do not describe a valid Huffman table.

Method Detail

### getLengths

    public short[] getLengths()

  Return an array of `short`s containing the number of values for each length in the Huffman table. The returned array is a copy.

  Returns:
    a `short` array where `array[k-1]` is equal to the number of values in the table of length `k`.
  See Also:
    `getValues()`

### getValues

    public short[] getValues()

  Return an array of `short`s containing the values arranged by increasing length of their corresponding codes. The interpretation of the array is dependent on the values returned from `getLengths`. The returned array is a copy.

  Returns:
    a `short` array of values.
  See Also:
    `getLengths()`

### toString

    public String toString()

  Description copied from class: `Object`
  Returns a string representation of the object. In general, the `toString` method returns a string that "textually represents" this object. The result should be a concise but informative representation that is easy for a person to read. It is recommended that all subclasses override this method.

  The `toString` method for class `Object` returns a string consisting of the name of the class of which the object is an instance, the at-sign character ``@`', and the unsigned hexadecimal representation of the hash code of the object. In other words, this method returns a string equal to the value of:

  >      getClass().getName() + '@' + Integer.toHexString(hashCode())

  Overrides:
    `toString` in class `Object`
  Returns:
    a string representation of the object.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2002 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.